local MAJOR, MINOR = "ButtonDaemon-1.0", 3
local ButtonDaemon, oldminor = LibStub:NewLibrary(MAJOR, MINOR)


if not ButtonDaemon then return end

function ButtonDaemon:NewButton(Border, Icon, templates)
	local button
	local inherit = "BD-1.0-RndTmpl"
	if templates then
		inherit = format("BD-1.0-RndTmpl, %s", templates)
	end
	button = CreateFrame("Button", nil, UIParent, inherit)
--	button:SetFrameStrata("TOOLTIP")
	local children = { button:GetRegions() }
	
	children[1]:SetTexture(Icon)
	children[1]:SetTexCoord(3/63, 60/63, 18/63, 45/63)
	children[2]:SetTexture(Icon)
	children[2]:SetTexCoord(6/63, 57/63, 14/63, 49/63)
	children[3]:SetTexture(Icon)
	children[3]:SetTexCoord(9/63, 54/63, 10/63, 53/63)
	children[4]:SetTexture(Icon)
	children[4]:SetTexCoord(13/63, 50/63, 6/63, 57/63)
	children[5]:SetTexture(Icon)
	children[5]:SetTexCoord(20/63, 43/63, 3/63, 60/63)
	
	button:SetNormalTexture(Border)
	button:SetHighlightTexture(Border)
	
	button.Resize = function(self, height, width)
		local children = { self:GetRegions() }
		children[1]:SetWidth(width*(58/64))
		children[1]:SetHeight(height*(28/64))
		children[2]:SetWidth(width*(52/64))
		children[2]:SetHeight(height*(36/64))
		children[3]:SetWidth(width*(46/64))
		children[3]:SetHeight(height*(44/64))
		children[4]:SetWidth(width*(38/64))
		children[4]:SetHeight(height*(52/64))
		children[5]:SetWidth(width*(24/64))
		children[5]:SetHeight(height*(58/64))
		self:SetWidth(width)
		self:SetHeight(height)	
	end
	
	button.Desaturate = function(self, sat)
		local children = {self:GetRegions()}
		local shad = children[1]:SetDesaturated(sat)
		if shad then
			children[2]:SetDesaturated(sat)
			children[3]:SetDesaturated(sat)
			children[4]:SetDesaturated(sat)
			children[5]:SetDesaturated(sat)
		else
			if sat then
				children[1]:SetVertexColor(0.5,0.5,0.5)
				children[2]:SetVertexColor(0.5,0.5,0.5)
				children[3]:SetVertexColor(0.5,0.5,0.5)
				children[4]:SetVertexColor(0.5,0.5,0.5)
				children[5]:SetVertexColor(0.5,0.5,0.5)
			else
				children[1]:SetVertexColor(1.0,1.0,1.0)
				children[2]:SetVertexColor(1.0,1.0,1.0)
				children[3]:SetVertexColor(1.0,1.0,1.0)
				children[4]:SetVertexColor(1.0,1.0,1.0)
				children[5]:SetVertexColor(1.0,1.0,1.0)
			end
		end
	end
	
	
	return button
end

function ButtonDaemon:ArrangeCircle(origin, radius, startangle, increment, buttons)
	local counter = 0
	
	for k, v in pairs(buttons) do
		buttons[k]:ClearAllPoints()
		buttons[k]:SetPoint("CENTER", origin, "CENTER", self:GetXY(radius,startangle+(increment*counter)))
		
		counter = counter + 1
		
	end
end

function ButtonDaemon:ArrangeStraight(origin, initx, inity, incx, incy, buttons)
	local counter = 0
	
	for k, v in pairs(buttons) do
		buttons[k]:ClearAllPoints()
		buttons[k]:SetPoint("CENTER", origin, "CENTER", initx + (incx * counter), inity + (incy * counter))
		counter = counter + 1
		
	end
end

function ButtonDaemon:GetXY(radius, angle)
	return radius*math.sin(math.rad(angle)), radius*math.cos(math.rad(angle))
end